package arc_eager;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;

/**
 * 
 * @author Miguel Ballesteros
 *
 */
public class Oracle {
	public Transition getTransition(ArrayList<String[]> stack, ArrayList<String[]> buffer, HashMap<String, String> leftMostChilds, HashMap<String,String> arcs){
		if (stack.isEmpty()) {
			return new Transition(0,null); //SHIFT
		}
		String s0Id=stack.get(stack.size()-1)[0];
		String s0Head=stack.get(stack.size()-1)[6];
		String b0Id=buffer.get(buffer.size()-1)[0];
		String b0Head=buffer.get(buffer.size()-1)[6];
		String leftMostChildb0Id=leftMostChilds.get(b0Id);
		if (leftMostChildb0Id==null) leftMostChildb0Id="0";
		//RIGHT ARC
		if (b0Id.equals(s0Head)){
			if (Parser.labelled) return new Transition(2,stack.get(stack.size()-1)[7]);	
			return new Transition(2,null);
		}
		//LEFT ARC
		else  if (s0Id.equals(b0Head)){
			if (Parser.labelled) return new Transition(3,buffer.get(buffer.size()-1)[7]);
			return new Transition(3,null);
		}
		//REDUCE
		else if(!s0Head.equals("0") && ((!b0Head.equals("0") && (Integer.parseInt(b0Head)<Integer.parseInt(s0Id))) 
				|| ((!leftMostChildb0Id.equals("0") && (Integer.parseInt(leftMostChildb0Id)<Integer.parseInt(s0Id)))))) {
			return new Transition(1,null);
		}
		//SHIFT
		else if ((!b0Head.equals("0") && Integer.parseInt(b0Head)<=Integer.parseInt(s0Id) ) 
				|| ((!leftMostChildb0Id.equals("0") && (Integer.parseInt(leftMostChildb0Id) <= Integer.parseInt(s0Id))))){
			return new Transition(0,null);	
		}
		return new Transition(0,null);	
	}
}
